/*!
 * main.c
 *
 * author: Roberto Piassi Passos Bodo
 *  email: rppbodo@gmail.com
 */

#include <stdio.h>
#include <string.h>

#include "global.h"
#include "init_functions.h"
#include "delta_times.h"
#include "player.h"
#include "table.h"
#include "matching.h"

int main(int argc, char** argv) {
	if (handle_arguments(argc, argv)) {
		return 1;
	}

	system("clear");
	if (set_midi_devices()) {
		return 1;
	}

	system("clear");
	if (load_input_file()) {
		return 1;
	}

	if (convert_delta_times()) {
		return 1;
	}

	if (player) {
		int i = 0;
		while (i < n_tracks) {
			play_track(i + 1, 5);
			i++;
		}
	}

	printf("\nwhich of these tracks will be the soloist's?\n");
	scanf("%d", &soloist_track);
	while (soloist_track < 2 || soloist_track > n_tracks) {
		fprintf(stderr, "error: invalid track... try again!\n");
		scanf("%d", &soloist_track);
	}

	if (fix_soloist_track()) {
		return 1;
	}

	system("clear");
	matching();

	return 0;
}

