/*
 * player.c
 *
 * author: Roberto Piassi Passos Bodo
 *  email: rppbodo@gmail.com
 */

#include "player.h"

/*!
 * This function gets the current computer time and returns its value in
 * milliseconds.
 */
long int get_current_time_() {
	long int milliseconds;
	gettimeofday(&current_time, NULL);
	milliseconds = (current_time.tv_sec - starting_time.tv_sec) * 1000;
	milliseconds += (current_time.tv_usec - starting_time.tv_usec) / 1000;
	return milliseconds;
}

/*!
 * This function plays the track received for the number of seconds received as well.
 */
void play_track(int track, int seconds) {
	int first;
	long int clock;
	Link link = table[track - 1];
	int notes[16][128];

	if (link != NULL) {
		first = link->delta_time;
		printf("\nplaying %d seconds of track #%d...\n", seconds, track);
		printf("starting time: %d ms...\n", first);
	} else {
		return;
	}

	gettimeofday(&starting_time, NULL);
	clock = get_current_time_() + first;
	while (clock < first + seconds * 1000) {
		while (link != NULL && (link->delta_time <= clock)) {
			if (144 <= link->bytes[0] && link->bytes[0] < 160) {
				notes[link->bytes[0]-144][link->bytes[1]] = 1;
			}
			write(output_device_fd, link->bytes, 3);
			link = link->next;
		}
		clock = get_current_time_() + first;
	}

	{
		int i, j;
		unsigned char bytes[3];
		for (i = 0; i < 16; i++) {
			for (j = 0; j < 128; j++) {
				if (notes[i][j] == 1) {
					bytes[0] = 144 + i;
					bytes[1] = j;
					bytes[2] = 0;
					write(output_device_fd, bytes, 3);
				}
			}
		}
	}
}
